## com.saxonica.schema
Class UserComplexType

    java.lang.Object
      com.saxonica.schema.SchemaStructure
          com.saxonica.schema.UserDefinedType
              com.saxonica.schema.UserComplexType

All Implemented Interfaces:
  SerializableSchemaComponent, UserSchemaComponent, java.io.Serializable, javax.xml.transform.SourceLocator, ComplexType, SchemaComponent, SchemaType

    public class UserComplexType

extends UserDefinedType
implements ComplexType, UserSchemaComponent, SerializableSchemaComponent

A user-defined complex type (that is, any complex type other than xs:anyType)

See Also:
  Serialized Form

Field Summary

Fields inherited from class com.saxonica.schema.UserDefinedType
`extendedTypes, finalProhibitions`

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Constructor Summary
`UserComplexType(SchemaAwareConfiguration config, javax.xml.transform.SourceLocator locator)` Creates a new user-defined Complextype

Method Summary
`void` `addAssertion(Assertion assertion)` Add an assertion to this complex type
`void` `addAttributeGroupReference(AttributeGroupReference attrGroupRef)` Adds the given AttributeGroupReference to this UserComplexType
`void` `addAttributeUse(AttributeUse use)` Adds the given AttributeUse to this UserComplexType.
`void` `addNonInheritedAttributeUse(AttributeUse use)` Add an attribute use to the final (combined) content model for this complex type.
`boolean` `allowsAttributes()` Return true if this type (or any known type derived from it by extension) allows the element to have one or more attributes.
`void` `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`Value` `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`void` `cancelValidation()` Cancel validation and compilation: this happens when the complex type is redefined
`static void` `checkTypeDerivation(ComplexType derived, SchemaType base, int block)` Check that a type is validly derived from a given type.
`void` `compile(SchemaCompiler compiler)` Compile the finite-state machine for validating instances against this type
`boolean` `computeIsAllContent()` Compute whether this complex type has a content model defined by an xs:all compositor (after simplification to remove pointless particles)
`void` `elaborate(SchemaCompiler compiler)` Elaborate the schema component: after reloading a serialized schema component model, this expands the component with derived information needed during validation episodes.
`protected static java.lang.String` `elementParticleMatches(ElementDecl base, ElementDecl sub, SchemaCompiler compiler)` Determine whether one element term matches another.
`boolean` `fixup(SchemaCompiler compiler)` Check references from this component to other components
`void` `gatherAllPermittedChildren(IntHashSet children)` Get a list of all the names of elements that can appear as children of an element having this complex type, as integer fingerprints.
`void` `gatherAllPermittedDescendants(IntHashSet descendants)` Get a list of all the names of elements that can appear as descendants of an element having this complex type, as integer fingerprints.
`ModelGroupParticle` `getAllCompositor()` For a complex type with "all" content, get the "all" model group.
`java.util.Set` `getAssertions()` Get the assertions defined on this complex type
`AttributeGroupDecl` `getAttributeGroup()` Returns the attribute group containing details of all the attributes defined for this complex type.
`SchemaType` `getAttributeUseType(int fingerprint)` Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the schema type associated with that attribute.
`int` `getBlock()` Returns the value of the 'block' attribute for this element
`AttributeGroupDecl` `getCombinedAttributeGroup()` Returns the attribute group containing details of all the attributes defined for this complex type.
`int` `getElementParticleCardinality(int fingerprint)` Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the cardinality associated with that element particle, that is, the number of times the element can occur within this complex type.
`SchemaType` `getElementParticleType(int fingerprint)` Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the schema type associated with that element particle.
`State` `getInitialState()` Get the initial dynamic state of the finite state machine used for validating against this type.
`Particle` `getParticle()` Get the (extended) particle representing the content model of this complex type.
`SimpleType` `getSimpleContentType()` For a complex type with simple content, return the simple type of the content.
`TypeReference` `getSimpleContentTypeReference()` Get the reference to the simple content type
`SequenceIterator` `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type
`boolean` `hasAssertions()` Test whether there are any assertions defined on this complex type
`boolean` `isAbstract()` Returns true if this UserComplexType has been marked as Abstract.
`boolean` `isAllContent()` Test whether this complex type has "all" content, that is, a content model using an xs:all compositor
`boolean` `isAtomicType()` Test whether this SchemaType is an atomic type
`boolean` `isComplexContent()` Returns true if this complexType has complex content: that is, if its {content type} is anything other than a simple type definition.
`boolean` `isEmptiable()` Test whether the content model of this complexType allows empty content
`boolean` `isEmptyContent()` Test whether the contentType of this complexType is empty
`boolean` `isMixedContent()` Determine whether this complex type allows mixed content
`boolean` `isRestricted()` Returns true if this complexType is a restriction
`boolean` `isSimpleContent()` Returns true if this complexType has simple content; that is, if its {content type} is a simple type definition
`boolean` `isSimpleType()` Test whether this SchemaType is a simple type
`java.lang.String` `isSubsumedBy(ComplexType base, SchemaCompiler compiler)` Test whether this complex type is subsumed by another complex type.
`boolean` `isValidRestriction(SchemaType base, SchemaCompiler compiler)` Determine whether this type is a valid restriction of another type
`java.util.Iterator` `iterateAssertions()` Iterate over all the assertions defined on this complex type
`void` `lookForCycles(java.util.Stack references, SchemaCompiler compiler)` This method is called to look for cycles.
`Particle` `makeExtendedParticle(SchemaCompiler compiler)` Get the particle corresponding to this UserComplexType, combining it with the content model of the base type if this type is derived by extension.
`void` `recompile(SchemaCompiler compiler)` Recompile the complex type when new members are added to the substitution group of an element
`void` `serialize(SchemaModelSerializer serializer)` Serialize the schema component
`void` `setAbstract(boolean isAbstract)` Sets whether or not this UserComplexType should be abstract.
`void` `setAnyAttribute(AttributeWildcard wildcard)` Sets the wildcard (anyAttribute) of the complexType.
`void` `setBlock(int block)` Sets the value of the 'block' attribute for this UserComplexType.
`void` `setComplexContent(boolean complexContent)` Sets whether or not this complexType is a 'complexContent'
`void` `setEmptyCombinedAttributeGroup()` Set the combined attribute group to an empty set of attributes.
`void` `setFiniteStateMachine(FiniteStateMachine machine)` Set the finite state machine.
`void` `setMixed(boolean isMixed)` Sets whether this complex type allows mixed content
`void` `setNonInheritedAnyAttribute(AttributeWildcard wildcard)` Sets the wildcard (anyAttribute) of the complexType on both the locally-declared and the combined attribute groups.
`void` `setParticle(Particle particle)` Sets the particle representing the content model of this complex type
`void` `setRestriction(boolean restricted)` Sets whether or not this complexType is a restriction
`void` `setSaxonDebug(boolean debug)` Set Saxon debugging on or off
`void` `setSimpleContent(boolean simpleContent)` Set that this complex type has (or does not have) simple content
`void` `setSimpleContentTypeReference(TypeReference ref)` For a complex type with simple content, set a reference to the simple type of the content
`java.lang.String` `subsumesAll(UserComplexType sub, SchemaCompiler compiler)` Test whether the particle of this complex type subsumes a complex type defined using xs:all
`boolean` `validate(SchemaCompiler compiler)` Checks the validity of this UserComplexType definition.

Methods inherited from class com.saxonica.schema.UserDefinedType

`allowsDerivation, checkTypeDerivationIsOK, containingDeclarationIsElement, getBaseType, getBaseTypeFingerprint, getBaseTypeReference, getContainingDeclarationName, getDerivationMethod, getDescription, getDisplayName, getFingerprint, getLocalName, getName, getNameCode, getNamePool, getTargetNamespace, hasRegisteredExtension, isAnonymousType, isComplexType, isExternalType, isSameType, iterateExtensionTypes, registerExtensionType, setBaseTypeReference, setContainingDeclaration, setDerivationMethod, setDerivationMethodName, setExtendedTypes, setFinalProhibitions, setNameCode`

Methods inherited from class com.saxonica.schema.SchemaStructure
`getColumnNumber, getConfiguration, getFixupStatus, getLineNumber, getPublicId, getSystemId, getValidationStatus, setConfiguration, setFixupStatus, setLineNumber, setLocator, setSystemId, setValidationStatus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.type.SchemaType
`allowsDerivation, checkTypeDerivationIsOK, getBaseType, getDerivationMethod, getDescription, getDisplayName, getFingerprint, getName, getNameCode, getSystemId, getTargetNamespace, isAnonymousType, isComplexType, isSameType`

Methods inherited from interface net.sf.saxon.type.SchemaComponent
`getValidationStatus`

Constructor Detail

### UserComplexType

    public UserComplexType(SchemaAwareConfiguration config,
                           javax.xml.transform.SourceLocator locator)

  Creates a new user-defined Complextype

  Parameters:
    `config` - the Configuration to which this user-defined complex type belongs
    `locator` - the location of this complex type within a schema document

Method Detail

### setSaxonDebug

    public void setSaxonDebug(boolean debug)

  Set Saxon debugging on or off

  Parameters:
    `debug` - true to switch debugging on; false to switch it off

### setFiniteStateMachine

    public void setFiniteStateMachine(FiniteStateMachine machine)

  Set the finite state machine. Used when restoring a serialized component model

  Parameters:
    `machine` - the FSM for this complex type

### addAttributeUse

    public void addAttributeUse(AttributeUse use)

  Adds the given AttributeUse to this UserComplexType. Doesn't throw an error if it's a duplicate: this is left to be checked at validation time

  Parameters:
    `use` - the AttributeUse to add to this UserComplexType

### setEmptyCombinedAttributeGroup

    public void setEmptyCombinedAttributeGroup()

  Set the combined attribute group to an empty set of attributes. Used when rebuilding a complex type from a saved SCM file

### addNonInheritedAttributeUse

    public void addNonInheritedAttributeUse(AttributeUse use)

  Add an attribute use to the final (combined) content model for this complex type. This is used when rebuilding a complex type from a saved SCM file; the difference is that in this case, all required attributes are added explicitly, and none are inherited from the base type.

  Parameters:
    `use` - the AttributeUse to add to this UserComplexType

### addAttributeGroupReference

    public void addAttributeGroupReference(AttributeGroupReference attrGroupRef)

  Adds the given AttributeGroupReference to this UserComplexType

  Parameters:
    `attrGroupRef` - the AttributeGroupReference to add to this UserComplexType

### getAttributeGroup

    public AttributeGroupDecl getAttributeGroup()

  Returns the attribute group containing details of all the attributes defined for this complex type. This method does not include the attributes defined on the base type: for that, use `getCombinedAttributeGroup()`

  Returns:
    an AttributeGroup holding the attribute details

### getCombinedAttributeGroup

    public AttributeGroupDecl getCombinedAttributeGroup()

  Returns the attribute group containing details of all the attributes defined for this complex type. This method also includes the attributes defined on the base type, and excludes any prohibited attributes

  Returns:
    an AttributeGroup holding the attribute details

### getBlock

    public int getBlock()

  Returns the value of the 'block' attribute for this element

  Specified by:
    `getBlock` in interface `SchemaType`
  Overrides:
    `getBlock` in class `UserDefinedType`
  Returns:
    the value of the 'block' attribute for this element

### isAbstract

    public boolean isAbstract()

  Returns true if this UserComplexType has been marked as Abstract.

  Specified by:
    `isAbstract` in interface `ComplexType`
  Returns:
    true if this UserComplexType is "abstract".

### isComplexContent

    public boolean isComplexContent()

  Returns true if this complexType has complex content: that is, if its {content type} is anything other than a simple type definition.

  Specified by:
    `isComplexContent` in interface `ComplexType`
  Returns:
    true if this complexType has complex content

### isSimpleContent

    public boolean isSimpleContent()

  Returns true if this complexType has simple content; that is, if its {content type} is a simple type definition

  Specified by:
    `isSimpleContent` in interface `ComplexType`
  Returns:
    true if this complexType has simple content

### setSimpleContent

    public void setSimpleContent(boolean simpleContent)

  Set that this complex type has (or does not have) simple content

  Parameters:
    `simpleContent` - true if the complex type has simple content

### isAllContent

    public boolean isAllContent()

  Test whether this complex type has "all" content, that is, a content model using an xs:all compositor

  Specified by:
    `isAllContent` in interface `ComplexType`
  Returns:
    true if the type has an "all" content model

### computeIsAllContent

    public boolean computeIsAllContent()
                                throws SchemaException

  Compute whether this complex type has a content model defined by an xs:all compositor (after simplification to remove pointless particles)

  Returns:
    true if the content model of the complex type is "all"
  Throws:
    `SchemaException`

### getAllCompositor

    public ModelGroupParticle getAllCompositor()

  For a complex type with "all" content, get the "all" model group. This method is always applied to the simplified content model (after removal of pointless particles)

  Returns:
    the "all" particle if there is one, or null otherwise.

### setSimpleContentTypeReference

    public void setSimpleContentTypeReference(TypeReference ref)

  For a complex type with simple content, set a reference to the simple type of the content

  Parameters:
    `ref` - a reference to a simple type

### getSimpleContentTypeReference

    public TypeReference getSimpleContentTypeReference()

  Get the reference to the simple content type

  Returns:
    a reference to a simple type, or null if the type is not a complex type with simple content

### getSimpleContentType

    public SimpleType getSimpleContentType()

  For a complex type with simple content, return the simple type of the content. Otherwise, return null.

  Specified by:
    `getSimpleContentType` in interface `ComplexType`
  Returns:
    For a complex type with simple content, returns the simple type of the content. Otherwise, returns null.

### isRestricted

    public boolean isRestricted()

  Returns true if this complexType is a restriction

  Specified by:
    `isRestricted` in interface `ComplexType`
  Returns:
    true if this complexType is a restriction

### isEmptyContent

    public boolean isEmptyContent()

  Test whether the contentType of this complexType is empty

  Specified by:
    `isEmptyContent` in interface `ComplexType`
  Returns:
    true if the content model is defined as empty

### isSimpleType

    public boolean isSimpleType()

  Test whether this SchemaType is a simple type

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a simple type

### isAtomicType

    public boolean isAtomicType()

  Test whether this SchemaType is an atomic type

  Specified by:
    `isAtomicType` in interface `SchemaType`
  Returns:
    true if this SchemaType is an atomic type

### setAbstract

    public void setAbstract(boolean isAbstract)

  Sets whether or not this UserComplexType should be abstract.

  Parameters:
    `isAbstract` - a boolean that when true makes this UserComplexType abstract.

### setAnyAttribute

    public void setAnyAttribute(AttributeWildcard wildcard)

  Sets the wildcard (anyAttribute) of the complexType. It is the caller's responsibility to check that there can be at most one attribute wildcard in a complex type definition.

  Parameters:
    `wildcard` - the attribute wildcard

### setNonInheritedAnyAttribute

    public void setNonInheritedAnyAttribute(AttributeWildcard wildcard)

  Sets the wildcard (anyAttribute) of the complexType on both the locally-declared and the combined attribute groups. Used when reloading the complex type from an SCM file.

  Parameters:
    `wildcard` - the attribute wildcard

### setBlock

    public void setBlock(int block)

  Sets the value of the 'block' attribute for this UserComplexType.

  Parameters:
    `block` - the value of the block attribute for this UserComplexType definition, as a bit-significant integer.

### setComplexContent

    public void setComplexContent(boolean complexContent)

  Sets whether or not this complexType is a 'complexContent'

  Parameters:
    `complexContent` - true if this complexType is a 'complexContent'

### setMixed

    public void setMixed(boolean isMixed)

  Sets whether this complex type allows mixed content

  Parameters:
    `isMixed` - if true, this type allows mixed content

### isMixedContent

    public boolean isMixedContent()

  Determine whether this complex type allows mixed content

  Specified by:
    `isMixedContent` in interface `ComplexType`
  Returns:
    true, if and only if this type allows mixed content

### setRestriction

    public void setRestriction(boolean restricted)

  Sets whether or not this complexType is a restriction

  Parameters:
    `restricted` - true if this complexType is a restriction

### setParticle

    public void setParticle(Particle particle)
                     throws SchemaException

  Sets the particle representing the content model of this complex type

  Parameters:
    `particle` - the Particle to add
  Throws:
    `SchemaException` - if the particle cannot be added (for example, because there is another with the same name in the same scope)

### addAssertion

    public void addAssertion(Assertion assertion)

  Add an assertion to this complex type

  Parameters:
    `assertion` - the assertion to be added

### hasAssertions

    public boolean hasAssertions()

  Test whether there are any assertions defined on this complex type

  Returns:
    true if there are any assertions

### iterateAssertions

    public java.util.Iterator iterateAssertions()

  Iterate over all the assertions defined on this complex type

  Returns:
    an iterator over the assertions defined on this type (which includes assertions inherited from its base type)

### getAssertions

    public java.util.Set getAssertions()

  Get the assertions defined on this complex type

  Returns:
    the set of asserts defined on this type, including those inherited from the base type

### lookForCycles

    public void lookForCycles(java.util.Stack references,
                              SchemaCompiler compiler)
                       throws SchemaException,
                              UnresolvedReferenceException

  This method is called to look for cycles. The object implementing this method is required (a) to raise an exception if the object itself appears in the list of references, (b) to add itself to the list of references, and (c) to call the lookForCycles method on all the objects that it references.

  Specified by:
    `lookForCycles` in interface `UserSchemaComponent`
  Overrides:
    `lookForCycles` in class `SchemaStructure`
  Parameters:
    `references` - A list of objects that contain direct or indirect references to this object, and that must therefore not be referred to from this object.
    `compiler` - used for error reporting
  Throws:
    `SchemaException`
    `UnresolvedReferenceException`

### fixup

    public boolean fixup(SchemaCompiler compiler)
                  throws SchemaException

  Check references from this component to other components

  Specified by:
    `fixup` in interface `UserSchemaComponent`
  Overrides:
    `fixup` in class `SchemaStructure`
  Parameters:
    `compiler` - used for error reporting
  Returns:
    true if all is well, false if errors found
  Throws:
    `SchemaException`

### validate

    public boolean validate(SchemaCompiler compiler)
                     throws SchemaException

  Checks the validity of this UserComplexType definition.

  Specified by:
    `validate` in interface `UserSchemaComponent`
  Returns:
    true when this Schema definition is valid, otherwise false.
  Throws:
    `SchemaException` - if the ErrorListener decides that an error is fatal.

### isValidRestriction

    public boolean isValidRestriction(SchemaType base,
                                      SchemaCompiler compiler)
                               throws SchemaException

  Determine whether this type is a valid restriction of another type

  Parameters:
    `base` - the specified base type
    `compiler` - used for error reporting
  Returns:
    true if this type is a valid restriction of the specified base type
  Throws:
    `SchemaException` - if an error occurs

### compile

    public void compile(SchemaCompiler compiler)
                 throws SchemaException

  Compile the finite-state machine for validating instances against this type

  Parameters:
    `compiler` - used for error reporting
  Throws:
    `SchemaException` - to indicate an invalid schema

### recompile

    public void recompile(SchemaCompiler compiler)
                   throws SchemaException,
                          ValidationException

  Recompile the complex type when new members are added to the substitution group of an element

  Parameters:
    `compiler` - user for error reporting
  Throws:
    `SchemaException`
    `ValidationException`

### cancelValidation

    public void cancelValidation()

  Cancel validation and compilation: this happens when the complex type is redefined

### getInitialState

    public State getInitialState()

  Get the initial dynamic state of the finite state machine used for validating against this type.

  Returns:
    the initial state of the machine. If this is null, then the complex type has an empty content model.

### makeExtendedParticle

    public Particle makeExtendedParticle(SchemaCompiler compiler)
                                  throws SchemaException

  Get the particle corresponding to this UserComplexType, combining it with the content model of the base type if this type is derived by extension. The resulting particle, as well as concatenating with the base content model if the type is derived by extension, will be simplified in that pointless particles will be removed and group references will be resolved (unless they have a significant minOccurs or maxOccurs).

  Parameters:
    `compiler` - used for error reporting. May be null if the schema has already been fully validated.
  Returns:
    The particle that combines the locally-defined content model with the content model of the type that this type is extending.
  Throws:
    `SchemaException` - if an error occurs

### getParticle

    public Particle getParticle()

  Get the (extended) particle representing the content model of this complex type. This must be called only on a UserComplexType that has been validated.

  Returns:
    the extended particle (the particle defined on this type, appended where necessary onto the particle of the type from which it is derived by extension)

### isEmptiable

    public boolean isEmptiable()

  Test whether the content model of this complexType allows empty content

  Specified by:
    `isEmptiable` in interface `ComplexType`
  Returns:
    true if empty content is valid

### getElementParticleType

    public SchemaType getElementParticleType(int fingerprint)

  Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the schema type associated with that element particle. If there is no such particle, return null. If the fingerprint matches an element wildcard, return the type of the global element declaration with the given name if one exists, or AnyType if none exists and lax validation is permitted by the wildcard.

  If the element particle is not defined within this type itself, try to find it within the types derived by extension from this type. If there is one extension that defines the particle, return the type of that particle. If there are several, then if the types are consistent, return that type, otherwise return AnyType. (We don't currently construct a union type).

  Specified by:
    `getElementParticleType` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
  Returns:
    the schema type associated with the child element particle with the given name. If there is no such particle, return null.

### getElementParticleCardinality

    public int getElementParticleCardinality(int fingerprint)

  Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the cardinality associated with that element particle, that is, the number of times the element can occur within this complex type. The value is one of `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, If there is no such particle, return `StaticProperty.EMPTY`.

  Specified by:
    `getElementParticleCardinality` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
  Returns:
    the cardinality associated with the child element particle with the given name. If there is no such particle, return `StaticProperty.EMPTY`.

### getAttributeUseType

    public SchemaType getAttributeUseType(int fingerprint)
                                   throws SchemaException,
                                          ValidationException

  Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the schema type associated with that attribute. If there is no such attribute use, return null. If the fingerprint matches an attribute wildcard, return the type of the global attribute declaration with the given name if one exists, or AnySimpleType if none exists and lax validation is permitted by the wildcard.

  Specified by:
    `getAttributeUseType` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
  Returns:
    the schema type associated with the attribute use identified by the fingerprint. If there is no such attribute use, return null.
  Throws:
    `SchemaException`
    `ValidationException`

### allowsAttributes

    public boolean allowsAttributes()

  Return true if this type (or any known type derived from it by extension) allows the element to have one or more attributes.

  Specified by:
    `allowsAttributes` in interface `ComplexType`
  Returns:
    true if attributes are allowed

### gatherAllPermittedChildren

    public void gatherAllPermittedChildren(IntHashSet children)
                                    throws SchemaException

  Get a list of all the names of elements that can appear as children of an element having this complex type, as integer fingerprints. If the list is unbounded (because of wildcards or the use of xs:anyType), return null.

  Specified by:
    `gatherAllPermittedChildren` in interface `ComplexType`
  Parameters:
    `children` - an integer set, initially empty, which on return will hold the fingerprints of all permitted child elements; if the result contains the value -1, this indicates that it is not possible to enumerate all the children, typically because of wildcards. In this case the other contents of the set should be ignored.
  Throws:
    `SchemaException`

### gatherAllPermittedDescendants

    public void gatherAllPermittedDescendants(IntHashSet descendants)
                                       throws SchemaException

  Get a list of all the names of elements that can appear as descendants of an element having this complex type, as integer fingerprints. If the list is unbounded (because of wildcards or the use of xs:anyType), return null.

  Specified by:
    `gatherAllPermittedDescendants` in interface `ComplexType`
  Parameters:
    `descendants` - an integer set, initially empty, which on return will hold the fingerprints of all permitted descendant elements; if the result contains the value -1, this indicates that it is not possible to enumerate all the descendants, typically because of wildcards. In this case the other contents of the set should be ignored.
  Throws:
    `SchemaException`

### isSubsumedBy

    public java.lang.String isSubsumedBy(ComplexType base,
                                         SchemaCompiler compiler)
                                  throws SchemaException

  Test whether this complex type is subsumed by another complex type. The algorithm used is as published by Thompson and Tobin, XML Europe 2003.

  Parameters:
    `base` - the other type (the type that this is derived from by restriction, validly or otherwise)
    `compiler` - used for error reporting
  Returns:
    null indicating that this type does indeed subsume the other; or a string indicating why it doesn't. If the string starts with "?", Saxon isn't able to prove subsumption one way or the other.
  Throws:
    `SchemaException`

### elementParticleMatches

    protected static java.lang.String elementParticleMatches(ElementDecl base,
                                                             ElementDecl sub,
                                                             SchemaCompiler compiler)

  Determine whether one element term matches another. This is a simplified version of the procedure in Edge.matches(), used only for xs:all content models

  Parameters:
    `base` - the element declaration used in the base type
    `sub` - the element declaration used in the derived type
    `compiler` - used for reporting warnings
  Returns:
    null if the edges match, otherwise a string explaining why there is no match.

### subsumesAll

    public java.lang.String subsumesAll(UserComplexType sub,
                                        SchemaCompiler compiler)
                                 throws SchemaException

  Test whether the particle of this complex type subsumes a complex type defined using xs:all

  Parameters:
    `sub` - the derived type
    `compiler` - used for error reporting
  Returns:
    null if this type validly subsumes the derived type; otherwise, a string that can be used as an error message to explain why the derivation is not valid
  Throws:
    `SchemaException`

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)
                                  throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` - the static context
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### getTypedValue

    public SequenceIterator getTypedValue(NodeInfo node)
                                   throws XPathException

  Get the typed value of a node that is annotated with this schema type

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    an iterator over the items in the typed value
  Throws:
    `XPathException`

### atomize

    public Value atomize(NodeInfo node)
                  throws XPathException

  Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method `getTypedValue(net.sf.saxon.om.NodeInfo)`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException`
  Since:
    8.5

### checkTypeDerivation

    public static void checkTypeDerivation(ComplexType derived,
                                           SchemaType base,
                                           int block)
                                    throws SchemaException

  Check that a type is validly derived from a given type. This method is used only for complex types.

  Parameters:
    `derived` - the derived type
    `base` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration
  Throws:
    `SchemaException` - if the derivation is not allowed

### elaborate

    public void elaborate(SchemaCompiler compiler)
                   throws SchemaException

  Elaborate the schema component: after reloading a serialized schema component model, this expands the component with derived information needed during validation episodes. The model is assumed to be valid.

  Specified by:
    `elaborate` in interface `UserSchemaComponent`
  Overrides:
    `elaborate` in class `SchemaStructure`
  Parameters:
    `compiler` -
  Throws:
    `SchemaException`

### serialize

    public void serialize(SchemaModelSerializer serializer)
                   throws XPathException

  Serialize the schema component

  Specified by:
    `serialize` in interface `SerializableSchemaComponent`
  Throws:
    `XPathException`

Copyright (c) Saxonica Limited. All rights reserved.